//-----------------------------------------------------------------------------
// Name: Poke Mochi
// Description:
// author: Shu Yu Lin
// date: Dec 10, 14
//-----------------------------------------------------------------------------
#include "RtAudio.h"
#include "chuck_fft.h"
#include <math.h>
#include <stdlib.h>
#include "Stk.h"
#include "dywapitchtrack.h"
#include "x-fun.h"
#include <iostream>
#include <map>

double limits = 0;
float X = 0;
float Y = -5;
const int MAX_PARTICLES = 900;
const int MIN_PARTICLES = 10;
int currentParticle = 1;
double posX[MAX_PARTICLES], posY[MAX_PARTICLES];

int button;
int num = 440;
bool roasted = false;
float g_score = 0;
float g_scoreForBurnt = 0;
bool burnt = false;

using namespace std;

#ifdef __MACOSX_CORE__
#include <GLUT/glut.h>
#include <OpenGL/gl.h>
#include <OpenGL/glu.h>
#else
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>

#endif


//-----------------------------------------------------------------------------
// function prototypes
//-----------------------------------------------------------------------------
void help();
void initGfx();
void idleFunc();
void displayFunc();
void reshapeFunc( GLsizei width, GLsizei height );
void keyboardFunc( unsigned char, int, int );
void mouseFunc( int button, int state, int x, int y );
void particle(float dx, float dy);
void generateKeys();
void updateScore(bool roasted);
void updateBurnt(bool burnt);

// our datetype
#define SAMPLE float
// corresponding format for RtAudio
#define MY_FORMAT RTAUDIO_FLOAT32
// sample rate
#define MY_SRATE 44100
// number of channels
//#define MY_CHANNELS 2
// for convenience
#define MY_PIE 3.14159265358979

// for pitch detection
#define MY_CHANNELS 1
//#define SAMPLE double
#define ZPF 1

// width and height
// 16:10; 16:9
long g_width = 600;
long g_height = 500;
long g_last_width = g_width;
long g_last_height = g_height;
// global buffer
SAMPLE * g_buffer;
// fft buffer
SAMPLE * g_fftBuf = NULL;
unsigned int g_bufferSize = 1024;
// window
SAMPLE * g_window = NULL;
long g_windowSize;

GLboolean g_fullscreen = FALSE;
GLfloat g_t = 0;
GLfloat g_t2 = 0;

// freeze display
GLboolean g_freeze = FALSE;

float g_xVertex = 0;
float g_yVertex = 0;
float g_yVertexForSpectrum = 0;

GLfloat x = 0;

//GLfloat g_log_positions[1024]; // precompute positions for log spacing
//
//
//// for waterfall
//struct Pt2D { float x; float y; };
//Pt2D ** g_spectrums = NULL;
//GLuint g_depth = 48; // for john: 64
//GLfloat g_z = 0.0f;
//GLboolean g_z_set = FALSE;
//GLfloat g_space = .12f; // for john: .1f
//GLboolean g_downsample = FALSE;
//GLint g_ds = 0; // downsample amount
//// which way the waterfall moves
//GLboolean g_backwards = TRUE;
//
//// draw analysis features
//GLboolean g_draw_features = TRUE;
//// starting a file
//GLint g_starting = 0;
//// the index associated with the waterfall
//GLint g_wf = 0;
//// plot waterfall
//GLboolean g_wutrfall = TRUE;
//// array of booleans for waterfall
//GLboolean * g_draw = NULL;
//// waveform
//GLboolean g_waveform = TRUE;
//
//
//// for time domain waterfall
//SAMPLE ** g_waveforms = NULL;
//GLfloat g_wf_delay_ratio = 1.0f / 3.0f;
//GLuint g_wf_delay = (GLuint)(g_depth * g_wf_delay_ratio + .5f);
//GLuint g_wf_index = 0;
//
//// gain
//GLfloat g_gain = 1.0f;
//GLfloat g_time_scale = 1.0f;
//GLfloat g_freq_scale = 1.0f;
//
//// how much to see
//GLint g_time_view = 1;
//GLint g_freq_view = 2;
//
//GLint g_fft_size = 1024;
//float inc = 3.6f;


// frequency
//SAMPLE g_freq = 0;
// the number of sample
SAMPLE g_t3 = 0;






// for pitch detection ////////////////////////////////////////////////////////////////////////////////
bool gen_sine = false;
bool pitch_listen = false;
bool stop_sound = false;
const int PITCH_ARRAY_LENGTH = 512;
double pitchArray[PITCH_ARRAY_LENGTH];
int g_theNextArrayIndex = 0;
SAMPLE g_freq = 440;
double average = 0;
dywapitchtracker pitchtracker;
bool colorDecision = false;
int start = 0;

map<double, string> keys;
XFun func;
int unsigned s = 512;

// mute
mutex g_mutex;
// mute audio
GLboolean g_mute = FALSE;



double * g_theDoubleBuffer;
double g_thePitchEstimate;

//-----------------------------------------------------------------------------
// name: callme()
// desc: audio callback
//-----------------------------------------------------------------------------
int callme( void * outputBuffer, void * inputBuffer, unsigned int numFrames,
            double streamTime, RtAudioStreamStatus status, void * data )
{
    
    
    // cast!
    SAMPLE * input = (SAMPLE *)inputBuffer;
    SAMPLE * output = (SAMPLE *)outputBuffer;
    
    
    
    
    
    // freeze frame
//    if(g_freeze) {
//        //cout << "true" << endl;
//        memset( input, 0, g_bufferSize * 2 * sizeof(SAMPLE) );
//        memset( output, 0, g_bufferSize * 2 * sizeof(SAMPLE) );
////        memset( input, 0, g_bufferSize * 2 * numFrames);
////        memset( output, 0, g_bufferSize * 2 * numFrames);
//        //return 0;
//        
//    } else {
//        //cout << "false" << endl;
//        for( int i = 0; i < numFrames; i++ ){
//            // assume mono
//            g_buffer[i] = input[i];
//            // zero output
//            output[i] = 0; //sin(2 * MY_PIE * 440 * g_t3 / MY_SRATE);
//            if (g_yVertexForSpectrum >= 0) {
//                if (2*sin(r)-1 <= x <= 2*sin(r)+1) {
//                    //cout << sin(r)*2 << endl;
//                    output[i] = (((float) rand()) / (float) RAND_MAX) * 2 - 1;
//                    //output[i] = sin(2 * MY_PIE * 1000 * g_t3 / MY_SRATE);
//                }
//            }
//        }
//    }
    
    
    // for pitch detection//////////////////////////////////////////////////////////////////////////////////////////////
    
    double the_pitch;

    for( int i = 0; i < numFrames; i++ ) {
        output[i] = 0;
        if (gen_sine) {
            output[i*MY_CHANNELS] = ::sin(2 * MY_PIE* g_freq * g_t / MY_SRATE);
            for( int j = 1; j < MY_CHANNELS; j++ ) output[i*MY_CHANNELS+j] = output[i*MY_CHANNELS];
            // increment sample number
            g_t += 1.0;
            //   	cout << i << ": " << output[i*MY_CHANNELS] << endl;
        }
        
        g_buffer[i] = input[i];
        //cout << pitchArray[i] << endl;
        
        // copy (as double)
        g_theDoubleBuffer[i] = input[i];
    }

    if (pitch_listen) {
        the_pitch = dywapitch_computepitch(&pitchtracker, g_theDoubleBuffer, start, numFrames);
        //cerr << "pitch: " << the_pitch << endl;
        //cout << numFrames << endl;
        
        //cout << *input << endl;
        
        if (the_pitch != 0 && g_theNextArrayIndex < PITCH_ARRAY_LENGTH )
        {
            pitchArray[g_theNextArrayIndex] = the_pitch;
            g_theNextArrayIndex++;
        }
    }
    
    //limits = *input;
    
    
    
    
    
    g_mutex.lock();
    g_mutex.unlock();
    // mute the real-time audio
    if( g_mute ) {
        memset( output, 0, g_bufferSize * 2 * sizeof(SAMPLE) );
    }
    
    g_t3 += 1.0;
    
    return 0;
}




//-----------------------------------------------------------------------------
// name: main()
// desc: entry point
//-----------------------------------------------------------------------------
int main( int argc, char ** argv )
{
    // initialize GLUT
    glutInit( &argc, argv );
    // init gfx
    initGfx();
    
    
    // for pitch tracker
    generateKeys();
    
    
    // instantiate RtAudio object
    RtAudio audio;
    // variables
    unsigned int bufferBytes = 0;
    // frame size
    unsigned int bufferFrames = 512;
    
    // check for audio devices
    if( audio.getDeviceCount() < 1 )
    {
        // nopes
        cout << "no audio devices found!" << endl;
        exit( 1 );
    }
    
       // let RtAudio print messages to stderr.
    audio.showWarnings( true );
    
    // set input and output parameters
    RtAudio::StreamParameters iParams, oParams;
    iParams.deviceId = audio.getDefaultInputDevice();
    iParams.nChannels = MY_CHANNELS;
    iParams.firstChannel = 0;
    oParams.deviceId = audio.getDefaultOutputDevice();
    oParams.nChannels = MY_CHANNELS;
    oParams.firstChannel = 0;
    
    // create stream options
    RtAudio::StreamOptions options;
    
    // go for it
    try {
        // open a stream
        audio.openStream( &oParams, &iParams, MY_FORMAT, MY_SRATE, &bufferFrames, &callme, NULL, &options );
        
        
        // for pitch detection ////////////////////////////////////////////////////////////////////////////////
        
        cerr << "Buffer size defined by RtAudio: " << g_bufferSize << endl;
        
        // allocate buffer for time domain
        g_buffer = new SAMPLE[g_bufferSize];
        
        // allocate buffer for time domain window
        g_window = new SAMPLE[g_bufferSize];
        if( g_window == NULL ) {
            cerr << "Something went wrong when creating the window" << endl;
            exit(1);
        }
        
        // the double buffer for pitch tracking
        g_theDoubleBuffer = new double[g_bufferSize];
        
        // start audio stream
        audio.startStream( );
        
        dywapitch_inittracking(&pitchtracker);
        
        // test RtAudio fuctionality for latency
        cout << "stream latency: " << audio.getStreamLatency( )
        << " frames" << endl;
    
        
    }
    catch( RtError& e )
    {
        // error!
        cout << e.getMessage() << endl;
        exit( 1 );
    }
    
    // compute
    bufferBytes = bufferFrames * MY_CHANNELS * sizeof(SAMPLE);
    // allocate global buffer
    g_bufferSize = bufferFrames;
    //g_buffer = new SAMPLE[g_bufferSize];
    g_fftBuf = new SAMPLE[g_bufferSize];
    //memset( g_buffer, 0, sizeof(SAMPLE)*g_bufferSize );
    memset( g_fftBuf, 0, sizeof(SAMPLE)*g_bufferSize );
    
    // allocate buffer to hold window
    g_windowSize = bufferFrames - 500;
    g_window = new SAMPLE[g_windowSize];
    // generate the window
    hanning( g_window, g_windowSize );
    
    // print help
    help();
    
    // go for it
    try {
        // start stream
        //audio.startStream();
        
//////        glEnable(GL_CULL_FACE);
//////            glCullFace(GL_BACK);
//////            glEnable(GL_DEPTH_TEST);
//////            glDepthFunc(GL_LESS);
//////            glEnable(GL_LIGHT0);
//////            glEnable(GL_NORMALIZE);
//////            glEnable(GL_COLOR_MATERIAL);
//////            glEnable(GL_LIGHTING);
//////            glLightfv(GL_LIGHT0, GL_AMBIENT,  light_ambient);
//////            glLightfv(GL_LIGHT0, GL_DIFFUSE,  light_diffuse);
//////            glLightfv(GL_LIGHT0, GL_SPECULAR, light_specular);
//////            glLightfv(GL_LIGHT0, GL_POSITION, light_position);
//////            glMaterialfv(GL_FRONT, GL_AMBIENT,   mat_ambient);
//////            glMaterialfv(GL_FRONT, GL_DIFFUSE,   mat_diffuse);
//////            glMaterialfv(GL_FRONT, GL_SPECULAR,  mat_specular);
//////            glMaterialfv(GL_FRONT, GL_SHININESS, high_shininess);
////        
        // let GLUT handle the current thread from here
        glutMainLoop();
        
        // stop the stream.
        audio.stopStream();
    }
    catch( RtError& e )
    {
        // print error message
        cout << e.getMessage() << endl;
        goto cleanup;
    }
    
cleanup:
    // close if open
    if( audio.isStreamOpen() )
        audio.closeStream();
    
    // done
    return 0;
}

// compute for frequency average from pitch array
double computePitchAverage() {
    //average = g_freq;
    // sanity check
    if( g_theNextArrayIndex == 0 ) return 0;
    
    double comp = 0;
    for (int i = 0; i < g_theNextArrayIndex; i++) {
        comp += pitchArray[i];
    }
    // cout << comp << endl;
    average = comp/g_theNextArrayIndex;
    cout << "frequency: " << g_freq << endl;
    cout << "your frequency: " << average << endl;
    return average;
}

// generate pitch
void generateKeys() {
    keys[36] = "C";
    keys[37] = "Db";
    keys[38] = "D";
    keys[39] = "Eb";
    keys[40] = "E";
    keys[41] = "F";
    keys[42] = "F#";
    keys[43] = "G";
    keys[44] = "G#";
    keys[45] = "A";
    keys[46] = "Bb";
    keys[47] = "B";
}




//-----------------------------------------------------------------------------
// Name: reshapeFunc( )
// Desc: called when window size changes
//-----------------------------------------------------------------------------
void initGfx() {
    // initialize GLUT
    //glutInit( &argc, argv );
    // double buffer, use rgb color, enable depth buffer
    glutInitDisplayMode( GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH );
    // initialize the window size
    glutInitWindowSize( g_width, g_height );
    // set the window postion
    glutInitWindowPosition( 100, 100 );
    // create the window
    glutCreateWindow( "Roast Mochi" );
    
    // set the idle function - called when idle
    glutIdleFunc( idleFunc );
    // set the display function - called when redrawing
    glutDisplayFunc( displayFunc );
    // set the reshape function - called when client area changes
    glutReshapeFunc( reshapeFunc );
    // set the keyboard function - called on keyboard events
    glutKeyboardFunc( keyboardFunc );
    // set the mouse function - called on mouse stuff
    glutMouseFunc( mouseFunc );
    
    //glClearColor( 165, 42, 42, 1.0);
    // enable color material
    glEnable( GL_COLOR_MATERIAL );
    // enable depth test
    glEnable( GL_DEPTH_TEST );
    
//    g_spectrums = new Pt2D *[g_depth];
//    for( int i = 0; i < g_depth; i++ )
//    {
//        g_spectrums[i] = new Pt2D[2048];
//        memset( g_spectrums[i], 0, sizeof(Pt2D)*2048 );
//    }
    
//    for( int i = 0; i < g_windowSize/2; i++ ) {
//        // color
//        glColor3f(1, 0.85 - fabs(g_buffer[i]), 0.72 - fabs(g_buffer[i]));
//    }
    
      //glClearColor(0.0f, 0.6f, 0.8f, 1.0f);

//    if (g_xVertex >= 2) {
//        if (2*sin(r)-1 <= g_yVertex <= 2*sin(r)+1) {
//            // set clear color
//            glClearColor( 255, 248, 220, 1 );
//        }
//    } else {
//        // set clear color
//        glClearColor( 0, 0, 0, 1 );
//    }
    
    // do our own initialization
   // initialize();
    
    // let GLUT handle the current thread from here
    //glutMainLoop();
    //return 0;

}

//-----------------------------------------------------------------------------
// Name: reshapeFunc( )
// Desc: called when window size changes
//-----------------------------------------------------------------------------
void reshapeFunc(GLsizei w, GLsizei h) {
    // save the new window size
    g_width = w;
    g_height = h;
    // map the view port to the client area
    glViewport( 0, 0, w, h );
    // set the matrix mode to project
    glMatrixMode( GL_PROJECTION );
    // load the identity matrix
    glLoadIdentity( );
    // create the viewing frustum
    gluPerspective( 45.0, (GLfloat) w / (GLfloat) h, 1.0, 300.0 );
    // set the matrix mode to modelview
    glMatrixMode( GL_MODELVIEW );
    // load the identity matrix
    glLoadIdentity( );
    // position the view point
    gluLookAt( 0.0f, 0.0f, 10.0f, 0.0f, 0.0f, 0.0f, 0.0f, 1.0f, 0.0f );
}


//-----------------------------------------------------------------------------
// Name: help( )
// Desc: print usage
//-----------------------------------------------------------------------------
void help() {
    cerr << "----------------------------------------------------" << endl;
    cerr << "Welcome to Roast Mochi! " << endl;
    cerr << "----------------------------------------------------" << endl;
    cerr << "Instruction: " << endl;
    cerr << "Press space bar to hear the pitch." << endl;
    cerr << "Press again to stop." << endl;
    cerr << "Hold the mouse and sing the pitch." << endl;
    cerr << "----------------------------------------------------" << endl;
    cerr << "'h' - print this help message" << endl;
    cerr << "'s' - toggle fullscreen" << endl;
    cerr << "'q' - quit visualization" << endl;
    cerr << "----------------------------------------------------" << endl;
}


//-----------------------------------------------------------------------------
// Name: keyboardFunc( )
// Desc: key event
//-----------------------------------------------------------------------------
void keyboardFunc(unsigned char key, int x, int y) {
    switch( key ) {
        case 'q': // quit
            exit(1);
            break;
        case 'h': // print help
            help();
            break;
            // toggle fullscreen
        case 's': {
            if( !g_fullscreen ) {
                g_last_width = g_width;
                g_last_height = g_height;
                glutFullScreen();
            }
            else
                glutReshapeWindow( g_last_width, g_last_height );
            // toggle variable value
            g_fullscreen = !g_fullscreen;
        }
        break;
        case 'f':
            g_freeze = !g_freeze;
            break;
        case 'm':
            g_mute = !g_mute;
            break;
        case 'r':
            g_score = 0;
            g_scoreForBurnt = 0;
            burnt = false;
            roasted = false;
            colorDecision = false;
            break;
            
            // for pitch detection //////////////////////////////////////////////////////////////////////
        case ' ':
            colorDecision = false;
            if (!stop_sound) {
                //	arrow_move = true;
                double curr_pitch = func.rand2i(24, 36);
                g_freq = func.midi2freq(curr_pitch);
                average = g_freq;
                //cout << "MIDI: " << curr_pitch << endl;
                //cout << "frequency: " << g_freq << endl;
                gen_sine = true;
                stop_sound = true;
            } else {
                gen_sine = false;
                stop_sound = false;
                //x_adj = 0.00;
                //y_adj = 0.00;
            }
            break;
    }
    // trigger redraw
    glutPostRedisplay( );
}




//-----------------------------------------------------------------------------
// Name: mouseFunc( )
// Desc: handles mouse stuff
//-----------------------------------------------------------------------------
void mouseFunc(int button, int state, int x, int y) {
    if (button == GLUT_LEFT_BUTTON) {
        // when left mouse button is down
        if (state == GLUT_DOWN) {
            pitch_listen = true;
            g_theNextArrayIndex = 0;
            //g_freeze = !g_freeze;
        } else {
            colorDecision = true;
            gen_sine = false;
            pitch_listen = false;
            double a = computePitchAverage();
            if (average <= g_freq - 10 || average >= g_freq + 10) {
                //glColor3f(0, 0, 0);
                burnt = true;
                roasted = false;
            } else {
                //glColor3f(0.9, 0.45, 0.32);
                burnt = false;
                roasted = true;
            }
        }
    } else if (button == GLUT_RIGHT_BUTTON) {
        // when right mouse button down
        if (state == GLUT_DOWN) {
            g_mute = !g_mute;
        } else {
        }
    }
    glutPostRedisplay( );
}




//-----------------------------------------------------------------------------
// Name: idleFunc( )
// Desc: callback from GLUT
//-----------------------------------------------------------------------------
void idleFunc() {
    // render the scene
    glutPostRedisplay( );
}

// moving fire
void moveParticles(int amount_of_particles) {
    srand (time (NULL) );
    float myX, myY;
    glColor3d(2, .5, 0);
    for (int i = 0; i < amount_of_particles; i++) {
        myX = rand() % 3 + 1;
        if(myX==1 && posX[i]<=1 ){
            int mytemp = rand() % 100 - 5;
            int temp = rand() % 5 + 1;
            posX[i]+=temp*.001;
            posY[i]+=mytemp*.0004;
        }
        if(myX==2){posX[i]+=.00;posY[i]+=.01;}
        if(myX==3 && posX[i]>=-1){
            int temp = rand() % 5 + 1;
            int mytemp = rand() % 100 - 5;
            posX[i]-=temp*.001;
            posY[i]+=mytemp*.0004;
        }
        if(posY[i]>=limits-1){
            posY[i]= -3;
            posX[i]= 0;
        }
    }
}

// fire
void particle(float dx, float dy) {
    int thingy = 1;
    bool check = false;
    /*
     glPushMatrix();
     glColor3d(.3, .1, 0);
     glTranslated(0, 0, -3);
     glutSolidCube(.3);
     glPopMatrix();
     */
    if (check == false) {
        float R, G, B;
        glPushMatrix();
        glBegin(GL_TRIANGLES);
        for (int i = 0; i < MAX_PARTICLES; i++) {
            //cout << "I'm about to draw." << endl;
            R = 178;
            G = 34;
            B = 34;
            glColor3f(R*.01, G*.01, B*.01);
            //glColor3d(10, 10, 0);
            //glColor3d(0, 0+posY[i], 0);
            glVertex2f(X+dx -.01, Y+dy);
            glVertex2f(X+.01+dx, Y+dy);
            glVertex2f(X+dx, Y+.02+dy);
            X = posX[i];
            Y = posY[i];
            }
            glEnd();
            glPopMatrix();
            check = true;
            }
            switch(thingy){
                case 1:
                    moveParticles(currentParticle);
                    if (currentParticle != MAX_PARTICLES) {
                        currentParticle++;
                    }
                    glutPostRedisplay();
                    break;
            }
}

// draw current score on the screen
void updateScore(bool roasted) {
    glColor3f(1.0, 1.0, 1.0);
    if(roasted){
        g_score++;
    }
    glPushMatrix();
    glRasterPos2f(-4.0, 3.3);
    stringstream myString;
    myString << "Roasted: " << (int)g_score;
    std::string scoresMsg = myString.str();
    int messageLength = (int)(scoresMsg.length());
    for (int i = 0; i < messageLength; i++) {
        glutBitmapCharacter(GLUT_BITMAP_9_BY_15, scoresMsg[i]);
    }
    glPopMatrix();
}

// update the number of burnt mochi
void updateBurnt(bool burnt) {
    glColor3f(1.0, 1.0, 1.0);
    if(burnt){
        g_scoreForBurnt++;
    }
    glPushMatrix();
    glRasterPos2f(-4.0, 2.8);
    stringstream myString;
    myString << "Burnt: " << (int)g_scoreForBurnt;
    std::string scoresMsg = myString.str();
    int messageLength = (int)(scoresMsg.length());
    for (int i = 0; i < messageLength; i++) {
        glutBitmapCharacter(GLUT_BITMAP_9_BY_15, scoresMsg[i]);
    }
    glPopMatrix();
}

// draw mochi
void mochi(float x, float y) {
    //g_xVertex = sin(r)*2;
    glTranslatef(x, y, 0);
    glPushMatrix();
    //glBegin(glutSolidSphere);
    GLfloat v = 1 + .1*::sin( g_t*3 ); g_t += .02;
    // scale factor: "wobble" along Y
    GLfloat w = 1 + .1*::sin( g_t2*3 ); g_t2 += .03;
    // scale
    glScalef(v, w, v);
    glutSolidSphere( 1, 200, 5 ); // radius, slice
    //glEnd();
    glPopMatrix();
}


//-----------------------------------------------------------------------------
// Name: displayFunc( )
// Desc: callback function invoked to draw the client area
//-----------------------------------------------------------------------------
void displayFunc() {
    glClearColor( 0.45, 0.00, 0.00, 1.0);
    // local state
    static GLfloat zrot = 0.0f, c = 0.0f;
    // clear the color and depth buffers
    glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
    // define a starting point
    x = -3;
    // compute increment for line dots
    GLfloat xinc = ::fabs(x*2 / g_bufferSize);
    updateBurnt(burnt);
    updateScore(roasted);
    
    // print if 5 mochi are roasted
    if (g_score >= 5) {
        glRasterPos2f(-1, 2.6);
        stringstream myString;
        myString << "Mochi are ready!";
        std::string scoresMsg = myString.str();
        int messageLength = (int)(scoresMsg.length());
        for (int i = 0; i < messageLength; i++) {
            glutBitmapCharacter(GLUT_BITMAP_9_BY_15, scoresMsg[i]);
        }
        glRasterPos2f(-1.3, 2.2);
        stringstream myString2;
        myString2 << "Press r to restart.";
        std::string scoresMsg2 = myString2.str();
        int messageLength2 = (int)(scoresMsg2.length());
        for (int i = 0; i < messageLength2; i++) {
            glutBitmapCharacter(GLUT_BITMAP_9_BY_15, scoresMsg2[i]);
        }
    }
    
    // print if 5 mochi are burnt
    if (g_scoreForBurnt >= 5) {
        glRasterPos2f(-2.3, 2.6);
        stringstream myString;
        myString << "You burnt the mochi and the house!";
        std::string scoresMsg = myString.str();
        int messageLength = (int)(scoresMsg.length());
        for (int i = 0; i < messageLength; i++) {
            glutBitmapCharacter(GLUT_BITMAP_9_BY_15, scoresMsg[i]);
        }
        glRasterPos2f(-1.3, 2.3);
        stringstream myString2;
        myString2 << "Press r to restart.";
        std::string scoresMsg2 = myString2.str();
        int messageLength2 = (int)(scoresMsg2.length());
        for (int i = 0; i < messageLength2; i++) {
            glutBitmapCharacter(GLUT_BITMAP_9_BY_15, scoresMsg2[i]);
        }
    }
    
    // save transformation state: KEEP THIS!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    glPushMatrix();
    
    // if score has not exceed 5, the game keeps going
    if (g_scoreForBurnt < 5 && g_score < 5) {
        for( int i = 0; i < g_windowSize/2; i++ ) {
            if (average == 0) {
                average = num;
            }
            glColor3f(1, 0.85 - fabs(g_buffer[i]), 0.72 - fabs(g_buffer[i]));
            if (colorDecision) {
                if (average <= g_freq - 10 || average >= g_freq + 10) {
                    glColor3f(0, 0, 0);
                    burnt = false;
                } else {
                    glColor3f(0.9, 0.45, 0.32);
                    roasted = false;
                }
            }
        }
        mochi(0, 1);
        
        // if 5 mochi are roasted, then present mochi stick
    } else if (g_score >= 5) {
        // rotate mochi
        int angleForWinningMochi = 0;
        float xForWinningMochi = -3;
        glColor3f(0.9, 0.45, 0.32);
        roasted = false;
//        for (int i = 0; i < 512; i++) {
//            //glTranslatef(3, 0, 0);
//            //glRotatef(angleForWinningMochi, 0, 0, 1);
//            glTranslatef(2*cos(xForWinningMochi), 2*sin(xForWinningMochi),0);
//            mochi(1, 0);
//        }
        glTranslatef(0, 1, 0);
        glPushMatrix();
        //glTranslatef(2*cos(xForWinningMochi), 2*sin(xForWinningMochi),0);
        mochi(0, 2*sin(xForWinningMochi));
        mochi(-1.8, 2*sin(xForWinningMochi) + 0.2);
        mochi(-2.0, 2*sin(xForWinningMochi) + 0.4);
//        mochi(2*cos(xForWinningMochi+0.01), 2*sin(xForWinningMochi+0.01));
//        mochi(2*cos(xForWinningMochi+0.02), 2*sin(xForWinningMochi+0.02));
//        mochi(2*cos(xForWinningMochi+0.03), 2*sin(xForWinningMochi+0.03));
//        mochi(2*cos(xForWinningMochi+0.04), 2*sin(xForWinningMochi+0.04));
        angleForWinningMochi += .5;
        xForWinningMochi += 0.02;
        glPopMatrix();
        
        // if 5 mochi are burnt, then set up the fire
    } else if (g_scoreForBurnt >= 5) {
        burnt = false;
        glColor3f(0, 0, 0);
        mochi(0, 1);
        
        particle(5, -4);
        particle(-6.5, -4);
        particle(-6, -4);
        particle(-5.5, -4);
        particle(-5, -4);
        particle(-4.5, -4);
        particle(-4, -4);
        particle(-3.5, -4);
        particle(-3, -4);
        particle(-2.5, -4);
        particle(-2, -4);
        particle(-1.5, -4);
        particle(-1, -4);
        particle(-0.5, -4);
        particle(0, -4);
        particle(0.5, -4);
        particle(1, -4);
        particle(1.5, -4);
        particle(2, -4);
        particle(2.5, -4);
        particle(3, -4);
        particle(3.5, -4);
        particle(4, -4);
        particle(4.5, -4);
        particle(5, -4);
        particle(5.5, -4);
        particle(6, -4);
        particle(6.5, -4);
        
        particle(5.2, -3);
        particle(-6.5, -3);
        particle(-6, -2.5);
        particle(-5.5, -2.8);
        particle(-5, -2.8);
        particle(-4.7, -2.8);
        particle(-4.2, -3.2);
        particle(-3.7, -2.8);
        particle(-3.2, -3);
        particle(-2.7, -2.6);
        particle(-2.2, -3);
        particle(-1.7, -2.8);
        particle(-1.2, -3.2); // y pattern end
        particle(-0.7, -3);
        particle(0.2, -2.8);
        particle(0.7, -3.2);
        particle(1.2, -2.8);
        particle(1.7, -3);
        particle(2.2, -2.6);
        particle(2.7, -3);
        particle(3.2, -2.8); // y pattern end
        particle(3.7, -3);
        particle(4.2, -2.8);
        particle(4.7, -3.2);
        particle(5, -3.5);
        particle(5.5, -4);
        particle(6, -4);
        
        particle(4.8, -2);
        particle(-6.5, -2);
        particle(-6, -2);
        particle(-5.5, -2);
        particle(-5, -2);
        particle(-4.3, -2);
        particle(-3.8, -2);
        particle(-3.3, -2);
        particle(-2.8, -2);
        particle(-2.3, -2);
        particle(-1.8, -2);
        particle(-1.3, -2);
        particle(-0.8, -2);
        particle(-0.3, -2);
        particle(-0.2, -2);
        particle(0.3, -2);
        particle(0.8, -2);
        particle(1.3, -2);
        particle(1.8, -2);
        particle(2.3, -2);
        particle(2.8, -2);
        particle(3.3, -2);
        particle(3.8, -2);
        particle(4.5, -3);
        particle(5, -3.5);
      
    }
    
    // mochi stick
    glColor3f(0.63, 0.32, 0.18);
    glRectf(-7, -0.1, 0.5, -0.2);

    //////////// draw grill //////
    //////// horizontal
    glColor3f(0.25, 0.25, 0.25);
    glRectf(-2.0, -2.1, 1.9, -2.15); // upper 1
    
    glColor3f(0.25, 0.25, 0.25);
    glRectf(-2.2, -2.3, 1.7, -2.35); // 3
    
    ////// slanted
    // right 1 (reference to center)
    glBegin(GL_POLYGON);
    glColor3f(0, 0, 0);
    glVertex2f(0.2f, -1.95f);
    glVertex2f(0.3f, -1.95f);
    glVertex2f(-0.2f, -2.5f);
    glVertex2f(-0.3f, -2.5f);
    glEnd();
    
    // right 2 (reference to center)
    glBegin(GL_POLYGON);
    glColor3f(0, 0, 0);
    glVertex2f(0.4f, -1.95f);
    glVertex2f(0.5f, -1.95f);
    glVertex2f(0.0f, -2.5f);
    glVertex2f(-0.1f, -2.5f);
    glEnd();
    
    // right 3 (reference to center)
    glBegin(GL_POLYGON);
    glColor3f(0, 0, 0);
    glVertex2f(0.6f, -1.95f);
    glVertex2f(0.7f, -1.95f);
    glVertex2f(0.2f, -2.5f);
    glVertex2f(0.1f, -2.5f);
    glEnd();
    
    // right 4 (reference to center)
    glBegin(GL_POLYGON);
    glColor3f(0, 0, 0);
    glVertex2f(0.8f, -1.95f);
    glVertex2f(0.9f, -1.95f);
    glVertex2f(0.4f, -2.5f);
    glVertex2f(0.3f, -2.5f);
    glEnd();
    
    // right 5 (reference to center)
    glBegin(GL_POLYGON);
    glColor3f(0, 0, 0);
    glVertex2f(1.0f, -1.95f);
    glVertex2f(1.1f, -1.95f);
    glVertex2f(0.6f, -2.5f);
    glVertex2f(0.5f, -2.5f);
    glEnd();

    // right 6 (reference to center)
    glBegin(GL_POLYGON);
    glColor3f(0, 0, 0);
    glVertex2f(1.2f, -1.95f);
    glVertex2f(1.3f, -1.95f);
    glVertex2f(0.8f, -2.5f);
    glVertex2f(0.7f, -2.5f);
    glEnd();

    // right 7 (reference to center)
    glBegin(GL_POLYGON);
    glColor3f(0, 0, 0);
    glVertex2f(1.4f, -1.95f);
    glVertex2f(1.5f, -1.95f);
    glVertex2f(1.0f, -2.5f);
    glVertex2f(0.9f, -2.5f);
    glEnd();
    
    // right 8 (reference to center)
    glBegin(GL_POLYGON);
    glColor3f(0, 0, 0);
    glVertex2f(1.6f, -1.95f);
    glVertex2f(1.7f, -1.95f);
    glVertex2f(1.2f, -2.5f);
    glVertex2f(1.1f, -2.5f);
    glEnd();
    
    // right 9 (reference to center)
    glBegin(GL_POLYGON);
    glColor3f(0, 0, 0);
    glVertex2f(1.8f, -1.95f);
    glVertex2f(1.9f, -1.95f);
    glVertex2f(1.4f, -2.5f);
    glVertex2f(1.3f, -2.5f);
    glEnd();
    
    // center
    glBegin(GL_POLYGON);
    glColor3f(0, 0, 0);
    glVertex2f(0.0f, -1.95f);
    glVertex2f(0.1f, -1.95f);
    glVertex2f(-0.4f, -2.5f);
    glVertex2f(-0.5f, -2.5f);
    glEnd();
    
    // left 1
    glBegin(GL_POLYGON);
    glColor3f(0, 0, 0);
    glVertex2f(-0.2f, -1.95f);
    glVertex2f(-0.1f, -1.95f);
    glVertex2f(-0.6f, -2.5f);
    glVertex2f(-0.7f, -2.5f);
    glEnd();
    
    // left 2
    glBegin(GL_POLYGON);
    glColor3f(0, 0, 0);
    glVertex2f(-0.4f, -1.95f);
    glVertex2f(-0.3f, -1.95f);
    glVertex2f(-0.8f, -2.5f);
    glVertex2f(-0.9f, -2.5f);
    glEnd();

    // left 3
    glBegin(GL_POLYGON);
    glColor3f(0, 0, 0);
    glVertex2f(-0.6f, -1.95f);
    glVertex2f(-0.5f, -1.95f);
    glVertex2f(-1.0f, -2.5f);
    glVertex2f(-1.1f, -2.5f);
    glEnd();
    
    // left 4
    glBegin(GL_POLYGON);
    glColor3f(0, 0, 0);
    glVertex2f(-0.8f, -1.95f);
    glVertex2f(-0.7f, -1.95f);
    glVertex2f(-1.2f, -2.5f);
    glVertex2f(-1.3f, -2.5f);
    glEnd();
    
    // left 5
    glBegin(GL_POLYGON);
    glColor3f(0, 0, 0);
    glVertex2f(-1.0f, -1.95f);
    glVertex2f(-0.9f, -1.95f);
    glVertex2f(-1.4f, -2.5f);
    glVertex2f(-1.5f, -2.5f);
    glEnd();
    
    // left 6
    glBegin(GL_POLYGON);
    glColor3f(0, 0, 0);
    glVertex2f(-1.2f, -1.95f);
    glVertex2f(-1.1f, -1.95f);
    glVertex2f(-1.6f, -2.5f);
    glVertex2f(-1.7f, -2.5f);
    glEnd();

    // left 7
    glBegin(GL_POLYGON);
    glColor3f(0, 0, 0);
    glVertex2f(-1.4f, -1.95f);
    glVertex2f(-1.3f, -1.95f);
    glVertex2f(-1.8f, -2.5f);
    glVertex2f(-1.9f, -2.5f);
    glEnd();
    
    // left 8
    glBegin(GL_POLYGON);
    glColor3f(0, 0, 0);
    glVertex2f(-1.6f, -1.95f);
    glVertex2f(-1.5f, -1.95f);
    glVertex2f(-2.0f, -2.5f);
    glVertex2f(-2.1f, -2.5f);
    glEnd();

    // horizontal below the slanted
    glColor3f(0.25, 0.25, 0.25);
    glRectf(-1.9, -2.0, 2.0, -2.05); // 1
    
    glColor3f(0.25, 0.25, 0.25);
    glRectf(-2.1, -2.2, 1.8, -2.25); // 3
    
    glColor3f(0.25, 0.25, 0.25);
    glRectf(-2.3, -2.4, 1.6, -2.45); // 5
    
    //////////// furnace /////////////////////////
    // right side
    glBegin(GL_POLYGON);
    glColor3f(0.1, 0.1, 0.1);
    glVertex2f(1.4f, -2.5f);
    glVertex2f(1.9f, -1.95f);
    glVertex2f(1.9f, -4.0f);
    glVertex2f(1.4f, -4.5f);
    glEnd();

    // blocks on the front of furnace
    glColor3f(0.38, 0.38, 0.38);
    glRectf(-1.7f, -2.8f, -1.1f, -4.2f); // left
    
    glColor3f(0.2, 0.2, 0.2);
    glRectf(-0.6f, -2.8f, 0.0f, -4.2f);
    
    glColor3f(0.38, 0.38, 0.38);
    glRectf(0.5f, -2.8f, 1.1f, -4.2f);
   
    //////////////// furnace front
    glColor3f(0.13, 0.13, 0.13);
    glRectf(-2.1f, -2.5f, 1.4f, -4.5f);
    
    // left side
    glBegin(GL_POLYGON);
    glColor3f(0.7, 0.13, 0.13);
    glVertex2f(-2.1f, -2.5f);
    glVertex2f(-1.6f, -1.95f);
    glVertex2f(-1.6f, -4.0f);
    glVertex2f(-2.1f, -4.5f);
    glEnd();
   
    glPopMatrix(); // KEEP THIS!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    

    // -----------------------------------THE FLAME--------------------------------------------------
    particle(0.1, 0);
    
    particle(0, 0);
    particle(0.1, 0);
    particle(-0.1, 0);
    particle(0, -0.1);
    
    particle(0.15, -0.05);
    particle(-0.2, -0.1);
    particle(0.25, -0.2);
    
    ////////////////////////////////////////// furnace back
    glColor3f(0.65, 0.27, 0.27);
    glRectf(-1.7f, -1.0f, 1.9f, -3.0f);
    
    // -----------------------------------THE END OF THE FLAME--------------------------------------------------

    
    /////// wall and floor (background) ///////////////
    glBegin(GL_POLYGON);
    glColor3f(0.35, 0, 0);
    glVertex2f(3.0f, 5.0f);
    glVertex2f(5.0f, 5.0f);
    glVertex2f(6.0f, -5.2f);
    glVertex2f(3.0f, -2.0f);
    glEnd();
    
    glBegin(GL_POLYGON);
    glColor3f(0, 0, 0);
    glVertex2f(-7.0f, -2.0f);
    glVertex2f(3.0f, -2.0f);
    glVertex2f(6.0f, -5.2f);
    glVertex2f(-7.0f, -5.2f);
    glEnd();
    
    // copy into the fft buf
    memcpy( g_fftBuf, g_buffer, sizeof(SAMPLE)*g_bufferSize );
    // apply window to buf
    apply_window( g_fftBuf, g_window, g_windowSize );
    // take forward FFT (time domain signal -> frequency domain signal)
    rfft( g_fftBuf, g_windowSize/2, FFT_FORWARD );
    // cast the result to a buffer of complex values (re,im)
    complex * cbuf = (complex *)g_fftBuf;
    
    // define a starting point
    x = -5;
    // compute increment
    // fabs float absolute value
    xinc = ::fabs(x*2 / (g_windowSize / 4));

    // loop over buffer to draw spectrum
    for( int i = 0; i < g_windowSize/2; i++ ) {
        //g_freeze = !g_freeze;
                // plot the magnitude,
                // with scaling, and also "compression" via pow(...)
                // open GL
                // use coordinate
                // x, y coordinates
        g_yVertexForSpectrum = 30*pow(cmp_abs(cbuf[i]), 0.5)-0.1;
        //g_yVertexForSpectrum is the limits
        //glVertex2f(x, g_yVertexForSpectrum);
        x += xinc;
        // update particle's limits variable
        limits = g_yVertexForSpectrum;
    }
    
        // end primitive
        glEnd();
    // restore transformations
    glPopMatrix();
    
    // flush!
    glFlush( );
    // swap the double buffer
    glutSwapBuffers( );
}

